

package ibspan.tss.oms.ontology;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.vocabulary.RDF;
import com.ibm.adtech.jastor.*;
import com.ibm.adtech.jastor.util.*;


/**
 * Implementation of {@link ibspan.tss.oms.ontology.ExtInfo}
 * Use the ibspan.tss.oms.ontology.OMSFactory to create instances of this class.
 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#ExtInfo)</p>
 * <br>
 */
public class ExtInfoImpl extends com.ibm.adtech.jastor.ThingImpl implements ibspan.tss.oms.ontology.ExtInfo {
	

	private static com.hp.hpl.jena.rdf.model.Property hasPositiveOntSrcProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasPositiveOntSrc");
	private java.util.ArrayList hasPositiveOntSrc;
	private static com.hp.hpl.jena.rdf.model.Property hasMainOntSrcProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasMainOntSrc");
	private ibspan.tss.oms.ontology.OntologySource hasMainOntSrc;
	private static com.hp.hpl.jena.rdf.model.Property hasUpdateDateTimeProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasUpdateDateTime");
	private java.lang.String hasUpdateDateTime;
	private static com.hp.hpl.jena.rdf.model.Property hasNegativeOntSrcProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasNegativeOntSrc");
	private java.util.ArrayList hasNegativeOntSrc;
	private static com.hp.hpl.jena.rdf.model.Property hasIncompleteCheckDateTimeProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasIncompleteCheckDateTime");
	private java.lang.String hasIncompleteCheckDateTime;
	private static com.hp.hpl.jena.rdf.model.Property hasCFProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasCF");
	private java.lang.Float hasCF;

	ExtInfoImpl(Resource resource, Model model) throws JastorException {
		super(resource, model);
		setupModelListener();
	}     
    	
	static ExtInfoImpl getExtInfo(Resource resource, Model model) throws JastorException {
		return new ExtInfoImpl(resource, model);
	}
	    
	static ExtInfoImpl createExtInfo(Resource resource, Model model) throws JastorException {
		ExtInfoImpl impl = new ExtInfoImpl(resource, model);
		
		if (!impl._model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl._resource, RDF.type, ExtInfo.TYPE)))
			impl._model.add(impl._resource, RDF.type, ExtInfo.TYPE);
		impl.addSuperTypes();
		impl.addHasValueValues();
		return impl;
	}
	
	void addSuperTypes() {
	}
   
	void addHasValueValues() {
	}
    
    private void setupModelListener() {
    	listeners = new java.util.ArrayList();
    	ibspan.tss.oms.ontology.OMSFactory.registerThing(this);
    }

	public java.util.List listStatements() {
		java.util.List list = new java.util.ArrayList();
		StmtIterator it = null;
		it = _model.listStatements(_resource,hasPositiveOntSrcProperty,(RDFNode)null);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,hasMainOntSrcProperty,(RDFNode)null);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,hasUpdateDateTimeProperty,(RDFNode)null);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,hasNegativeOntSrcProperty,(RDFNode)null);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,hasIncompleteCheckDateTimeProperty,(RDFNode)null);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,hasCFProperty,(RDFNode)null);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,RDF.type, ibspan.tss.oms.ontology.ExtInfo.TYPE);
		while (it.hasNext()) {
			list.add(it.next());
		}
		return list;
	}
	
	public void clearCache() {
		hasPositiveOntSrc = null;
		hasMainOntSrc = null;
		hasUpdateDateTime = null;
		hasNegativeOntSrc = null;
		hasIncompleteCheckDateTime = null;
		hasCF = null;
	}


	private void initHasPositiveOntSrc() throws JastorException {
		this.hasPositiveOntSrc = new java.util.ArrayList();
		StmtIterator it = _model.listStatements(_resource, hasPositiveOntSrcProperty, (RDFNode)null);
		while(it.hasNext()) {
			com.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();
			if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
				throw new JastorInvalidRDFNodeException (uri() + ": One of the http://www.ibspan.waw.pl/tss/OMS#hasPositiveOntSrc properties in ExtInfo model not a Resource", stmt.getObject());
			com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
			if (true) { // don't check resource type if the property range is Resource
				ibspan.tss.oms.ontology.OntologySource hasPositiveOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
				this.hasPositiveOntSrc.add(hasPositiveOntSrc);
			}
		}
	}

	public java.util.Iterator getHasPositiveOntSrc() throws JastorException {
		if (hasPositiveOntSrc == null)
			initHasPositiveOntSrc();
		return new com.ibm.adtech.jastor.util.CachedPropertyIterator(hasPositiveOntSrc,_resource,hasPositiveOntSrcProperty,true);
	}

	public void addHasPositiveOntSrc(ibspan.tss.oms.ontology.OntologySource hasPositiveOntSrc) throws JastorException {
		if (this.hasPositiveOntSrc == null)
			initHasPositiveOntSrc();
		if (this.hasPositiveOntSrc.contains(hasPositiveOntSrc)) {
			this.hasPositiveOntSrc.remove(hasPositiveOntSrc);
			this.hasPositiveOntSrc.add(hasPositiveOntSrc);
			return;
		}
		this.hasPositiveOntSrc.add(hasPositiveOntSrc);
		_model.add(_model.createStatement(_resource,hasPositiveOntSrcProperty,hasPositiveOntSrc.resource()));
	}
	
	public ibspan.tss.oms.ontology.OntologySource addHasPositiveOntSrc() throws JastorException {
		ibspan.tss.oms.ontology.OntologySource hasPositiveOntSrc = ibspan.tss.oms.ontology.OMSFactory.createOntologySource(_model.createResource(),_model);
		if (this.hasPositiveOntSrc == null)
			initHasPositiveOntSrc();
		this.hasPositiveOntSrc.add(hasPositiveOntSrc);
		_model.add(_model.createStatement(_resource,hasPositiveOntSrcProperty,hasPositiveOntSrc.resource()));
		return hasPositiveOntSrc;
	}
	
	public ibspan.tss.oms.ontology.OntologySource addHasPositiveOntSrc(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		ibspan.tss.oms.ontology.OntologySource hasPositiveOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
		if (this.hasPositiveOntSrc == null)
			initHasPositiveOntSrc();
		if (this.hasPositiveOntSrc.contains(hasPositiveOntSrc))
			return hasPositiveOntSrc;
		this.hasPositiveOntSrc.add(hasPositiveOntSrc);
		_model.add(_model.createStatement(_resource,hasPositiveOntSrcProperty,hasPositiveOntSrc.resource()));
		return hasPositiveOntSrc;
	}
	
	public void removeHasPositiveOntSrc(ibspan.tss.oms.ontology.OntologySource hasPositiveOntSrc) throws JastorException {
		if (this.hasPositiveOntSrc == null)
			initHasPositiveOntSrc();
		if (!this.hasPositiveOntSrc.contains(hasPositiveOntSrc))
			return;
		if (!_model.contains(_resource, hasPositiveOntSrcProperty, hasPositiveOntSrc.resource()))
			return;
		this.hasPositiveOntSrc.remove(hasPositiveOntSrc);
		_model.removeAll(_resource, hasPositiveOntSrcProperty, hasPositiveOntSrc.resource());
	}
		 

	public ibspan.tss.oms.ontology.OntologySource getHasMainOntSrc() throws JastorException {
		if (hasMainOntSrc != null)
			return hasMainOntSrc;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, hasMainOntSrcProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
			throw new JastorInvalidRDFNodeException(uri() + ": hasMainOntSrc getProperty() in ibspan.tss.oms.ontology.ExtInfo model not Resource", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
		hasMainOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
		return hasMainOntSrc;
	}

	public void setHasMainOntSrc(ibspan.tss.oms.ontology.OntologySource hasMainOntSrc) throws JastorException {
		if (_model.contains(_resource,hasMainOntSrcProperty)) {
			_model.removeAll(_resource,hasMainOntSrcProperty,null);
		}
		this.hasMainOntSrc = hasMainOntSrc;
		if (hasMainOntSrc != null) {
			_model.add(_model.createStatement(_resource,hasMainOntSrcProperty, hasMainOntSrc.resource()));
		}			
	}
		
	public ibspan.tss.oms.ontology.OntologySource setHasMainOntSrc() throws JastorException {
		if (_model.contains(_resource,hasMainOntSrcProperty)) {
			_model.removeAll(_resource,hasMainOntSrcProperty,null);
		}
		ibspan.tss.oms.ontology.OntologySource hasMainOntSrc = ibspan.tss.oms.ontology.OMSFactory.createOntologySource(_model.createResource(),_model);
		this.hasMainOntSrc = hasMainOntSrc;
		_model.add(_model.createStatement(_resource,hasMainOntSrcProperty, hasMainOntSrc.resource()));
		return hasMainOntSrc;
	}
	
	public ibspan.tss.oms.ontology.OntologySource setHasMainOntSrc(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		if (_model.contains(_resource,hasMainOntSrcProperty)) {
			_model.removeAll(_resource,hasMainOntSrcProperty,null);
		}
		ibspan.tss.oms.ontology.OntologySource hasMainOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
		this.hasMainOntSrc = hasMainOntSrc;
		_model.add(_model.createStatement(_resource,hasMainOntSrcProperty, hasMainOntSrc.resource()));
		return hasMainOntSrc;
	}
	
	public java.lang.String getHasUpdateDateTime() throws JastorException {
		if (hasUpdateDateTime != null)
			return hasUpdateDateTime;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, hasUpdateDateTimeProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": hasUpdateDateTime getProperty() in ibspan.tss.oms.ontology.ExtInfo model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = Util.fixLiteral(literal.getValue(),"java.lang.String");
		hasUpdateDateTime = (java.lang.String)obj;
		return hasUpdateDateTime;
	}
	
	public void setHasUpdateDateTime(java.lang.String hasUpdateDateTime) throws JastorException {
		if (_model.contains(_resource,hasUpdateDateTimeProperty)) {
			_model.removeAll(_resource,hasUpdateDateTimeProperty,null);
		}
		this.hasUpdateDateTime = hasUpdateDateTime;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (hasUpdateDateTime != null) {
			_model.add(_model.createStatement(_resource,hasUpdateDateTimeProperty, _model.createTypedLiteral(hasUpdateDateTime)));
		}	
	}


	private void initHasNegativeOntSrc() throws JastorException {
		this.hasNegativeOntSrc = new java.util.ArrayList();
		StmtIterator it = _model.listStatements(_resource, hasNegativeOntSrcProperty, (RDFNode)null);
		while(it.hasNext()) {
			com.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();
			if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
				throw new JastorInvalidRDFNodeException (uri() + ": One of the http://www.ibspan.waw.pl/tss/OMS#hasNegativeOntSrc properties in ExtInfo model not a Resource", stmt.getObject());
			com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
			if (true) { // don't check resource type if the property range is Resource
				ibspan.tss.oms.ontology.OntologySource hasNegativeOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
				this.hasNegativeOntSrc.add(hasNegativeOntSrc);
			}
		}
	}

	public java.util.Iterator getHasNegativeOntSrc() throws JastorException {
		if (hasNegativeOntSrc == null)
			initHasNegativeOntSrc();
		return new com.ibm.adtech.jastor.util.CachedPropertyIterator(hasNegativeOntSrc,_resource,hasNegativeOntSrcProperty,true);
	}

	public void addHasNegativeOntSrc(ibspan.tss.oms.ontology.OntologySource hasNegativeOntSrc) throws JastorException {
		if (this.hasNegativeOntSrc == null)
			initHasNegativeOntSrc();
		if (this.hasNegativeOntSrc.contains(hasNegativeOntSrc)) {
			this.hasNegativeOntSrc.remove(hasNegativeOntSrc);
			this.hasNegativeOntSrc.add(hasNegativeOntSrc);
			return;
		}
		this.hasNegativeOntSrc.add(hasNegativeOntSrc);
		_model.add(_model.createStatement(_resource,hasNegativeOntSrcProperty,hasNegativeOntSrc.resource()));
	}
	
	public ibspan.tss.oms.ontology.OntologySource addHasNegativeOntSrc() throws JastorException {
		ibspan.tss.oms.ontology.OntologySource hasNegativeOntSrc = ibspan.tss.oms.ontology.OMSFactory.createOntologySource(_model.createResource(),_model);
		if (this.hasNegativeOntSrc == null)
			initHasNegativeOntSrc();
		this.hasNegativeOntSrc.add(hasNegativeOntSrc);
		_model.add(_model.createStatement(_resource,hasNegativeOntSrcProperty,hasNegativeOntSrc.resource()));
		return hasNegativeOntSrc;
	}
	
	public ibspan.tss.oms.ontology.OntologySource addHasNegativeOntSrc(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		ibspan.tss.oms.ontology.OntologySource hasNegativeOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
		if (this.hasNegativeOntSrc == null)
			initHasNegativeOntSrc();
		if (this.hasNegativeOntSrc.contains(hasNegativeOntSrc))
			return hasNegativeOntSrc;
		this.hasNegativeOntSrc.add(hasNegativeOntSrc);
		_model.add(_model.createStatement(_resource,hasNegativeOntSrcProperty,hasNegativeOntSrc.resource()));
		return hasNegativeOntSrc;
	}
	
	public void removeHasNegativeOntSrc(ibspan.tss.oms.ontology.OntologySource hasNegativeOntSrc) throws JastorException {
		if (this.hasNegativeOntSrc == null)
			initHasNegativeOntSrc();
		if (!this.hasNegativeOntSrc.contains(hasNegativeOntSrc))
			return;
		if (!_model.contains(_resource, hasNegativeOntSrcProperty, hasNegativeOntSrc.resource()))
			return;
		this.hasNegativeOntSrc.remove(hasNegativeOntSrc);
		_model.removeAll(_resource, hasNegativeOntSrcProperty, hasNegativeOntSrc.resource());
	}
		 
	public java.lang.String getHasIncompleteCheckDateTime() throws JastorException {
		if (hasIncompleteCheckDateTime != null)
			return hasIncompleteCheckDateTime;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, hasIncompleteCheckDateTimeProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": hasIncompleteCheckDateTime getProperty() in ibspan.tss.oms.ontology.ExtInfo model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = Util.fixLiteral(literal.getValue(),"java.lang.String");
		hasIncompleteCheckDateTime = (java.lang.String)obj;
		return hasIncompleteCheckDateTime;
	}
	
	public void setHasIncompleteCheckDateTime(java.lang.String hasIncompleteCheckDateTime) throws JastorException {
		if (_model.contains(_resource,hasIncompleteCheckDateTimeProperty)) {
			_model.removeAll(_resource,hasIncompleteCheckDateTimeProperty,null);
		}
		this.hasIncompleteCheckDateTime = hasIncompleteCheckDateTime;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (hasIncompleteCheckDateTime != null) {
			_model.add(_model.createStatement(_resource,hasIncompleteCheckDateTimeProperty, _model.createTypedLiteral(hasIncompleteCheckDateTime)));
		}	
	}

	public java.lang.Float getHasCF() throws JastorException {
		if (hasCF != null)
			return hasCF;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, hasCFProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": hasCF getProperty() in ibspan.tss.oms.ontology.ExtInfo model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = Util.fixLiteral(literal.getValue(),"java.lang.Float");
		hasCF = (java.lang.Float)obj;
		return hasCF;
	}
	
	public void setHasCF(java.lang.Float hasCF) throws JastorException {
		if (_model.contains(_resource,hasCFProperty)) {
			_model.removeAll(_resource,hasCFProperty,null);
		}
		this.hasCF = hasCF;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (hasCF != null) {
			_model.add(_model.createStatement(_resource,hasCFProperty, _model.createTypedLiteral(hasCF)));
		}	
	}
 


	private java.util.ArrayList listeners;
	
	public void registerListener(ThingListener listener) {
		if (!(listener instanceof ExtInfoListener))
			throw new IllegalArgumentException("ThingListener must be instance of ExtInfoListener"); 
		if (listeners == null)
			setupModelListener();
		if(!this.listeners.contains(listener)){
			this.listeners.add((ExtInfoListener)listener);
		}
	}
	
	public void unregisterListener(ThingListener listener) {
		if (!(listener instanceof ExtInfoListener))
			throw new IllegalArgumentException("ThingListener must be instance of ExtInfoListener"); 
		if (listeners == null)
			return;
		if (this.listeners.contains(listener)){
			listeners.remove(listener);
		}
	}



	
		public void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {

			if (stmt.getPredicate().equals(hasPositiveOntSrcProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					ibspan.tss.oms.ontology.OntologySource _hasPositiveOntSrc = null;
					try {
						_hasPositiveOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
					if (hasPositiveOntSrc == null) {
						try {
							initHasPositiveOntSrc();
						} catch (JastorException e) {
							e.printStackTrace();
							return;
						}
					}
					if (!hasPositiveOntSrc.contains(_hasPositiveOntSrc))
						hasPositiveOntSrc.add(_hasPositiveOntSrc);
					if (listeners != null) {
						java.util.ArrayList consumersForHasPositiveOntSrc;
						synchronized (listeners) {
							consumersForHasPositiveOntSrc = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForHasPositiveOntSrc.iterator();iter.hasNext();){
							ExtInfoListener listener=(ExtInfoListener)iter.next();
							listener.hasPositiveOntSrcAdded(ibspan.tss.oms.ontology.ExtInfoImpl.this,_hasPositiveOntSrc);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasMainOntSrcProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				hasMainOntSrc = null;
				if (true) { // don't check resource type if the property range is Resource
					try {
						hasMainOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
				}
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ExtInfoListener listener=(ExtInfoListener)iter.next();
						listener.hasMainOntSrcChanged(ibspan.tss.oms.ontology.ExtInfoImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasUpdateDateTimeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				hasUpdateDateTime = (java.lang.String)Util.fixLiteral(literal.getValue(),"java.lang.String");
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ExtInfoListener listener=(ExtInfoListener)iter.next();
						listener.hasUpdateDateTimeChanged(ibspan.tss.oms.ontology.ExtInfoImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasNegativeOntSrcProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					ibspan.tss.oms.ontology.OntologySource _hasNegativeOntSrc = null;
					try {
						_hasNegativeOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
					if (hasNegativeOntSrc == null) {
						try {
							initHasNegativeOntSrc();
						} catch (JastorException e) {
							e.printStackTrace();
							return;
						}
					}
					if (!hasNegativeOntSrc.contains(_hasNegativeOntSrc))
						hasNegativeOntSrc.add(_hasNegativeOntSrc);
					if (listeners != null) {
						java.util.ArrayList consumersForHasNegativeOntSrc;
						synchronized (listeners) {
							consumersForHasNegativeOntSrc = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForHasNegativeOntSrc.iterator();iter.hasNext();){
							ExtInfoListener listener=(ExtInfoListener)iter.next();
							listener.hasNegativeOntSrcAdded(ibspan.tss.oms.ontology.ExtInfoImpl.this,_hasNegativeOntSrc);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasIncompleteCheckDateTimeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				hasIncompleteCheckDateTime = (java.lang.String)Util.fixLiteral(literal.getValue(),"java.lang.String");
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ExtInfoListener listener=(ExtInfoListener)iter.next();
						listener.hasIncompleteCheckDateTimeChanged(ibspan.tss.oms.ontology.ExtInfoImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasCFProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				hasCF = (java.lang.Float)Util.fixLiteral(literal.getValue(),"java.lang.Float");
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ExtInfoListener listener=(ExtInfoListener)iter.next();
						listener.hasCFChanged(ibspan.tss.oms.ontology.ExtInfoImpl.this);
					}
				}
				return;
			}
		}
		
		public void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(hasPositiveOntSrcProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					ibspan.tss.oms.ontology.OntologySource _hasPositiveOntSrc = null;
					if (hasPositiveOntSrc != null) {
						boolean found = false;
						for (int i=0;i<hasPositiveOntSrc.size();i++) {
							ibspan.tss.oms.ontology.OntologySource __item = (ibspan.tss.oms.ontology.OntologySource) hasPositiveOntSrc.get(i);
							if (__item.resource().equals(resource)) {
								found = true;
								_hasPositiveOntSrc = __item;
								break;
							}
						}
						if (found)
							hasPositiveOntSrc.remove(_hasPositiveOntSrc);
						else {
							try {
								_hasPositiveOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
							} catch (JastorException e) {
							}
						}
					} else {
						try {
							_hasPositiveOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
						} catch (JastorException e) {
						}
					}
					if (listeners != null) {
						java.util.ArrayList consumersForHasPositiveOntSrc;
						synchronized (listeners) {
							consumersForHasPositiveOntSrc = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForHasPositiveOntSrc.iterator();iter.hasNext();){
							ExtInfoListener listener=(ExtInfoListener)iter.next();
							listener.hasPositiveOntSrcRemoved(ibspan.tss.oms.ontology.ExtInfoImpl.this,_hasPositiveOntSrc);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasMainOntSrcProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
					if (hasMainOntSrc != null && hasMainOntSrc.resource().equals(resource))
						hasMainOntSrc = null;				
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ExtInfoListener listener=(ExtInfoListener)iter.next();
						listener.hasMainOntSrcChanged(ibspan.tss.oms.ontology.ExtInfoImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasUpdateDateTimeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = Util.fixLiteral(literal.getValue(),"java.lang.String");
				if (hasUpdateDateTime != null && hasUpdateDateTime.equals(obj))
					hasUpdateDateTime = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ExtInfoListener listener=(ExtInfoListener)iter.next();
						listener.hasUpdateDateTimeChanged(ibspan.tss.oms.ontology.ExtInfoImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasNegativeOntSrcProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					ibspan.tss.oms.ontology.OntologySource _hasNegativeOntSrc = null;
					if (hasNegativeOntSrc != null) {
						boolean found = false;
						for (int i=0;i<hasNegativeOntSrc.size();i++) {
							ibspan.tss.oms.ontology.OntologySource __item = (ibspan.tss.oms.ontology.OntologySource) hasNegativeOntSrc.get(i);
							if (__item.resource().equals(resource)) {
								found = true;
								_hasNegativeOntSrc = __item;
								break;
							}
						}
						if (found)
							hasNegativeOntSrc.remove(_hasNegativeOntSrc);
						else {
							try {
								_hasNegativeOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
							} catch (JastorException e) {
							}
						}
					} else {
						try {
							_hasNegativeOntSrc = ibspan.tss.oms.ontology.OMSFactory.getOntologySource(resource,_model);
						} catch (JastorException e) {
						}
					}
					if (listeners != null) {
						java.util.ArrayList consumersForHasNegativeOntSrc;
						synchronized (listeners) {
							consumersForHasNegativeOntSrc = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForHasNegativeOntSrc.iterator();iter.hasNext();){
							ExtInfoListener listener=(ExtInfoListener)iter.next();
							listener.hasNegativeOntSrcRemoved(ibspan.tss.oms.ontology.ExtInfoImpl.this,_hasNegativeOntSrc);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasIncompleteCheckDateTimeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = Util.fixLiteral(literal.getValue(),"java.lang.String");
				if (hasIncompleteCheckDateTime != null && hasIncompleteCheckDateTime.equals(obj))
					hasIncompleteCheckDateTime = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ExtInfoListener listener=(ExtInfoListener)iter.next();
						listener.hasIncompleteCheckDateTimeChanged(ibspan.tss.oms.ontology.ExtInfoImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasCFProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = Util.fixLiteral(literal.getValue(),"java.lang.Float");
				if (hasCF != null && hasCF.equals(obj))
					hasCF = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						ExtInfoListener listener=(ExtInfoListener)iter.next();
						listener.hasCFChanged(ibspan.tss.oms.ontology.ExtInfoImpl.this);
					}
				}
				return;
			}
		}

	//}
	


}