

package ibspan.tss.oms.ontology;

import com.hp.hpl.jena.rdf.model.*;

/**
 * Interface for OntologySource ontology class<br>
 * Use the ibspan.tss.oms.ontology.OMSFactory to create instances of this interface.
 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#OntologySource)</p>
 * <br>
 * <br>
 * <br>
 */
public interface OntologySource extends com.ibm.adtech.jastor.Thing {
	
	/**
	 * The rdf:type for this ontology class
     */
	public static final Resource TYPE = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/OMS#OntologySource");
	

	/**
	 * The Jena Property for hasWrongTripples 
	 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#hasWrongTripples)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property hasWrongTripplesProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasWrongTripples");


	/**
	 * The Jena Property for hasCorrectTripples 
	 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#hasCorrectTripples)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property hasCorrectTripplesProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasCorrectTripples");


	/**
	 * The Jena Property for hasURL 
	 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#hasURL)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property hasURLProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasURL");


	/**
	 * The Jena Property for hasCF 
	 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#hasCF)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property hasCFProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasCF");






	/**
	 * Gets the 'hasWrongTripples' property value
	 * @return		{@link java.lang.Integer}
	 * @see			#hasWrongTripplesProperty
	 */
	public java.lang.Integer getHasWrongTripples() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'hasWrongTripples' property value
	 * @param		{@link java.lang.Integer}
	 * @see			#hasWrongTripplesProperty
	 */
	public void setHasWrongTripples(java.lang.Integer hasWrongTripples) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'hasCorrectTripples' property value
	 * @return		{@link java.lang.Integer}
	 * @see			#hasCorrectTripplesProperty
	 */
	public java.lang.Integer getHasCorrectTripples() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'hasCorrectTripples' property value
	 * @param		{@link java.lang.Integer}
	 * @see			#hasCorrectTripplesProperty
	 */
	public void setHasCorrectTripples(java.lang.Integer hasCorrectTripples) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'hasURL' property value
	 * @return		{@link java.lang.String}
	 * @see			#hasURLProperty
	 */
	public java.lang.String getHasURL() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'hasURL' property value
	 * @param		{@link java.lang.String}
	 * @see			#hasURLProperty
	 */
	public void setHasURL(java.lang.String hasURL) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'hasCF' property value
	 * @return		{@link java.lang.Float}
	 * @see			#hasCFProperty
	 */
	public java.lang.Float getHasCF() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'hasCF' property value
	 * @param		{@link java.lang.Float}
	 * @see			#hasCFProperty
	 */
	public void setHasCF(java.lang.Float hasCF) throws com.ibm.adtech.jastor.JastorException;

}